unit FNread1;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  FNread2,
  xygraph,
//  Streams,
  StdCtrls;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    Memo1: TMemo;
    Edit1: TEdit;
    Label1: TLabel;
    Button1: TButton;
    Label2: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    Edit3: TEdit;
    SaveDialog1: TSaveDialog;
    Button3: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const
  PADS_START: String = '*PADS-POWERLOGIC-V4.0*';
  PADS_END: String = '*END*';
  PADS_CONTROL: String = '*SCH*';
  PADS_REMARK: String = '*REMARK*';
  PADS_LINES: String = '*LINES*';
  PADS_TEXT: String = '*TEXT*';
  PADS_CAEDECAL: String = '*CAEDECAL*';
  PADS_PARTTYPE: String = '*PARTTYPE*';
  PADS_PART: String = '*PART*';
  PADS_BUSSES: String = '*BUSSES*';
  PADS_TIEDOTS: String = '*TIEDOTS*';
  PADS_CONNECTION: String = '*CONNECTION*';
  PADS_NETNAMES: String = '*NETNAMES*';
  CRLF: String = Char(13)+Char(10);

  ZoomFactor: Integer = 50;        // Convert pixels to mils


type Tlinespec = packed record
    ID: Byte;             // = 02
    Lines: Byte;
    ID2: Byte;
    OriginX: SmallInt;
    OriginY: SmallInt;
    DeltaX: SmallInt;
    DeltaY: SmallInt;
    ID11: Byte;
    ID12: Byte;
    ID13: Byte;
    ID14: Byte;
    ID15: Byte;
    end;

type Ttextspec = packed record
    ID: Byte;             // = 03
    Lines: Byte;
    Mode: Byte;           // 0=COM, 5=SIG, etc
    LocX: SmallInt;
    LocY: SmallInt;
    ID7: Byte;
    ID8: Byte;
    Height: Byte;         // 2,3,4,5,6,7,2 (N), 9,11,12,23,29,33,12 (R)
    ID10: Byte;
    Font: Byte;           // 0=1, $20=2, $40=3, $60=4, $80=5, $A0=6, $C0=7
                          // or $06 = rotated
                          // or $10 = RJ, or $01 = CJ
    ID12: Byte;
    POEX: Byte;
    POEY: Byte;
    ID15: Byte;
    Text: Array[0..15] of Char;
    end;

type Tcompspec = packed record
    ID: Byte;             // = 01
    Lines: Byte;
    ID2: Byte;
    OriginX: SmallInt;
    OriginY: SmallInt;
    DeltaX: SmallInt;
    DeltaY: SmallInt;
    SeqNum: SmallInt;
    ID13: Byte;
    ID14: Byte;
    ID15: Byte;
    end;

type Totherspec = packed record
    ID: Byte;             // = 02
    Lines: Byte;
    ID2: Byte;
    OriginX: SmallInt;
    OriginY: SmallInt;
    DeltaX: SmallInt;
    DeltaY: SmallInt;
    ID11: Byte;
    ID12: Byte;
    ID13: Byte;
    ID14: Byte;
    ID15: Byte;
    end;

type PADSTextSpec = packed record
     SpecString: String; // LocX LocY Rot Just Height Width
     TextString: String;
     end;

type PADSLineHeader = String; // Name LineType LocX LocY Pieces Text

type PADSLineSpec = String; // Type NumCoord Width LineStyle X_Coord Y_Coord

var
  Form1: TForm1;
  FileName: String;
  FileStream: TFileStream;
  FileBuffer: Array[0..1024] of Byte;
  DataLine: String;
  SizeX,SizeY: Integer;
  FilePointer: LongInt;
  dx1,dx2,dy1,dy2: Integer;
  PADSTextArray: TStrings; // Array of PADSTextSpec;
  PADSLineArray: TStrings;
  Written: Integer;
  FNzoom: Integer;

procedure MakePADSTextFile;
procedure AddText( Dest: PChar; Source: PChar );

implementation

{$R *.DFM}

//uses      Form2;

procedure TForm1.Button1Click(Sender: TObject);
var       i,j: Integer;
          RecordID: Byte;
          LineSpec: Tlinespec;
          TextSpec: Ttextspec;
          CompSpec: Tcompspec;
          OtherSpec: Totherspec;
          ExtraText: Array[0..15] of Char;
          TextArray: Array[0..255] of Char;
          Text: String;
          TempText: String;
          Piece: Integer;
          OriginX, OriginY: Integer;
          TextHeight, Font: Integer;
          Rotation: Integer;

begin
  OpenDialog1.Execute;
  FileName := OpenDialog1.FileName;
  if FileExists(FileName) then begin
    Piece := 0;
    FNZoom := 1;
    PADSTextArray := TStringList.Create;
    PADSLineArray := TStringList.Create;
    Memo1.Lines.Clear;
    Edit1.Text := FileName;
    FileStream := TFileStream.Create(FileName,fmOpenRead);
    FileStream.Read(FileBuffer,80);
    For i := 0 to 79 do
      Memo1.Lines.Add( Format('%3d:  %5d     %5x', [i, FileBuffer[i],FileBuffer[i]] ));
    SizeX := FileBuffer[7]+256*FileBuffer[8];
    SizeY := FileBuffer[9]+256*FileBuffer[10];
    Edit2.Text := IntToStr(SizeX);
    Edit3.Text := IntToStr(SizeY);
    dx1 := 2;
    dx2 := 98;
    dy1 := 2;
    dy2 := 98;
    Form2.visible := true;
    with Form2 do begin
    xycleargraph(PaintBox1,clBlack,clYellow,1);
    xystartgraph(PaintBox1.Left, PaintBox1.Left + PaintBox1.Width,
      PaintBox1.Top, PaintBox1.Top + PaintBox1.Height,
      dx1,dx2,dy1,dy2, FALSE);
//  xystartgraph(0,100,0,100,50,10,10,50,clipon);
//    xystartgraph(0, 400, 0, 200,  dx1,dx2,dy1,dy2, clipon);
    xyxaxis(clWhite,0,SizeX,20,1,'x axis',true, false, true);
    xyyaxis(clWhite,0,SizeY,20,1,'y axis', 1, true, false, true);
    paintbox1.canvas.pen.width := 2;
    end;
    Repeat
      FilePointer := FileStream.Position;
      FileStream.Read(RecordID,1);
      FileStream.Seek(FilePointer, soFromBeginning);
      If RecordID = 2 then begin  // LINES
        FileStream.Read(LineSpec,sizeof(Tlinespec));
        Memo1.Lines.Add( Format('Line style %d from %d,%d to %d,%d',
          [Byte(LineSpec.ID11)+1, LineSpec.OriginX, LineSpec.OriginY,
          LineSpec.OriginX+LineSpec.DeltaX, LineSpec.OriginY+LineSpec.DeltaY ] ));
        Memo1.Lines.Add( Format('ID2: %d ID12: %d ID13: %d ID14: %d ID15: %d',
          [Byte(LineSpec.ID2), Byte(LineSpec.ID12), Byte(LineSpec.ID13),
          Byte(LineSpec.ID14), Byte(LineSpec.ID15) ] ));

        OriginX := ZoomFactor*LineSpec.OriginX;
        OriginY := ZoomFactor*(SizeY-LineSpec.OriginY);
        Text := 'NAME' + IntToStr(Piece) + ' LINES '
         + IntToStr(OriginX) + ' ' +
          IntToStr(OriginY) + ' 1 0';
        PADSLineArray.Add(Text);

        Text := 'OPEN 2 10 255';
        PADSLineArray.Add(Text);

        Text := IntToStr(ZoomFactor*(LineSpec.OriginX)-OriginX) + ' ' +
          IntToStr(ZoomFactor*(SizeY-LineSpec.OriginY)-OriginY);
        PADSLineArray.Add(Text);

        Text := IntToStr(ZoomFactor*(LineSpec.OriginX+LineSpec.DeltaX)-OriginX) + ' ' +
          IntToStr(ZoomFactor*( SizeY - (LineSpec.OriginY+LineSpec.DeltaY))-OriginY );
        PADSLineArray.Add(Text);

        Form2.paintbox1.canvas.pen.width := 2;
        xymove( FNzoom*LineSpec.OriginX, SizeY-FNzoom*LineSpec.OriginY );
        xydraw( (FNzoom*LineSpec.OriginX+FNzoom*LineSpec.DeltaX),
          SizeY-(FNzoom*LineSpec.OriginY+FNzoom*LineSpec.DeltaY) );
        end

      else if RecordID = 3 then begin // TEXT
        FileStream.Read(TextSpec,sizeof(Ttextspec));
        TextArray := '';
        AddText( TextArray, TextSpec.Text );
//        Text := TextSpec.Text;
        If TextSpec.Lines > 2 then begin
          for i := 3 to TextSpec.Lines do begin
            FileStream.Read(ExtraText,sizeof(ExtraText));
            AddText( TextArray, ExtraText );
//            Text := Text + ExtraText;
            end;
          end;
        Text := TextArray;
        Font := ( (TextSpec.Font and $E0) shr 5 ) + 1;
        TextHeight := Font;
        If Font = 7 then TextHeight := 1;
        If (TextSpec.Font and $06) > 0 then
          Rotation := 90
        else
          Rotation := 0;
        Memo1.Lines.Add( Format('Text mode %d height %d rotation %d at %d,%d = %s',
          [ TextSpec.Mode, TextHeight, Rotation, TextSpec.LocX, TextSpec.LocY, Text ] ));
        TempText := IntToStr(ZoomFactor*TextSpec.LocX) + ' ' +
          IntToStr(ZoomFactor*(SizeY-TextSpec.LocY-TextHeight)) +
          ' ' + IntToStr(Rotation) + ' 0 ' +IntToStr(ZoomFactor*TextHeight) + ' 10';
        PADSTextArray.Add(TempText);
        PADSTextArray.Add(Text);

        Form2.PaintBox1.Canvas.Font.Height := FNzoom*2*TextHeight;
        Form2.PaintBox1.Canvas.Font.Name := 'Courier New';
        xytext(clWhite, Text, FNzoom*TextSpec.LocX, SizeY-FNzoom*TextSpec.LocY,1,1,0);
        end

      else if RecordID = 1 then begin // COMPONENT
        FileStream.Read(CompSpec,sizeof(Tcompspec));
        If CompSpec.Lines > 1 then begin
          Text := '';
          for i := 2 to CompSpec.Lines do begin
            FileStream.Read(ExtraText,sizeof(ExtraText));
            for j := 0 to 15 do
              Text := Text + Format('%x ', [Integer(ExtraText[j]) ]);
            end;
          end;
        Memo1.Lines.Add( Format('Component number %d at %d, %d size %d by %d with %d lines',
          [ CompSpec.SeqNum, CompSpec.OriginX, CompSpec.OriginY,
          CompSpec.DeltaX, CompSpec.DeltaY, CompSpec.Lines ] ) );
        Memo1.Lines.Add( Text );
        OriginX := ZoomFactor*LineSpec.OriginX;
        OriginY := ZoomFactor*(SizeY-LineSpec.OriginY);
        Text := 'NAME' + IntToStr(Piece) + ' LINES '
         + IntToStr(OriginX) + ' ' +
          IntToStr(OriginY) + ' 1 0';
        PADSLineArray.Add(Text);

        Text := 'CLOSED 5 5 0';
        PADSLineArray.Add(Text);

        Text := IntToStr(ZoomFactor*(CompSpec.OriginX)-OriginX) + ' ' +
          IntToStr(ZoomFactor*(SizeY-CompSpec.OriginY)-OriginY);
        PADSLineArray.Add(Text); // start

        Text := IntToStr(ZoomFactor*(CompSpec.OriginX+CompSpec.DeltaX)-OriginX) + ' ' +
          IntToStr(ZoomFactor*(SizeY-CompSpec.OriginY)-OriginY);
        PADSLineArray.Add(Text); //2

        Text := IntToStr(ZoomFactor*(CompSpec.OriginX+CompSpec.DeltaX)-OriginX) + ' ' +
          IntToStr(ZoomFactor*( SizeY - (CompSpec.OriginY+CompSpec.DeltaY))-OriginY );
        PADSLineArray.Add(Text); //3

        Text := IntToStr(ZoomFactor*(CompSpec.OriginX)-OriginX) + ' ' +
          IntToStr(ZoomFactor*( SizeY - (CompSpec.OriginY+CompSpec.DeltaY))-OriginY );
        PADSLineArray.Add(Text); //4

        Text := IntToStr(ZoomFactor*(CompSpec.OriginX)-OriginX) + ' ' +
          IntToStr(ZoomFactor*(SizeY-CompSpec.OriginY)-OriginY);
        PADSLineArray.Add(Text); // end

        Form2.paintbox1.canvas.pen.width := 1;
        xymove( FNzoom*CompSpec.OriginX, SizeY-FNzoom*CompSpec.OriginY );
        xydraw( (FNzoom*CompSpec.OriginX + FNzoom*CompSpec.DeltaX),
          SizeY-FNzoom*CompSpec.OriginY );
        xydraw( (FNzoom*CompSpec.OriginX + FNzoom*CompSpec.DeltaX),
          SizeY-(FNzoom*CompSpec.OriginY + FNzoom*CompSpec.DeltaY) );
        xydraw( FNzoom*CompSpec.OriginX,
          SizeY-(FNzoom*CompSpec.OriginY + FNzoom*CompSpec.DeltaY) );
        xydraw( FNzoom*CompSpec.OriginX, SizeY-FNzoom*CompSpec.OriginY );
        end

      else begin
        FileStream.Read( OtherSpec, sizeof(Totherspec) );
        Memo1.Lines.Add( Format('ID: %d from %d,%d to %d,%d',
          [Byte(OtherSpec.ID), OtherSpec.OriginX, OtherSpec.OriginY,
          OtherSpec.OriginX+OtherSpec.DeltaX, OtherSpec.OriginY+OtherSpec.DeltaY ] ));
        Memo1.Lines.Add( Format('ID2: %d ID11: %d ID12: %d ID13: %d ID14: %d ID15: %d',
          [Byte(OtherSpec.ID2), Byte(OtherSpec.ID11), Byte(OtherSpec.ID12),Byte(OtherSpec.ID13),
          Byte(OtherSpec.ID14), Byte(OtherSpec.ID15) ] ));
        end;
      Inc(Piece);
    Until FileStream.Position >= FileStream.Size;
//    Form2.PaintBox1.BringToFront;
    FileStream.Free;
//    Form2.PaintBox1.Show;
//    Form2.PaintBox1.Repaint;

  end;
end;

procedure AddText( Dest: PChar; Source: PChar );
var       DestPtr, SourcePtr: Integer;
begin
  DestPtr := Length(Dest);
  For SourcePtr := 0 to Length(Source)-1 do begin
    If (Source[SourcePtr] >= ' ') and (Source[SourcePtr] <= '~') then begin
      If DestPtr < 255 then
        Dest[DestPtr] := Source[SourcePtr];
      Inc( DestPtr );
      end
    else begin
      If DestPtr < 255 then
        Dest[DestPtr] := '?';
      Inc( DestPtr );
      end
    end;
  If DestPtr < 255 then
    Dest[DestPtr] := char(0);
end;

procedure MakePADSTextFile;
var       PADSfile: TFileStream;
          FileBuffer: AnsiString;
          MemoLine: Integer;
begin
  if Form1.SaveDialog1.Execute then begin
    PADSfile := TFileStream.Create(Form1.SaveDialog1.FileName,fmCreate or fmShareDenyNone);
    FileBuffer := PADS_START+CRLF;
    Written := PADSfile.Write(pchar(FileBuffer)^, StrLen(PChar(FileBuffer)) );
    FileBuffer := PADS_CONTROL+CRLF;
    Written := PADSfile.Write(pchar(FileBuffer)^, StrLen(PChar(FileBuffer)) );
    FileBuffer := PADS_TEXT+CRLF;
    Written := PADSfile.Write(pchar(FileBuffer)^, StrLen(PChar(FileBuffer)) );
    FileBuffer := PADSTextArray.Text;
    Written := PADSfile.Write(pchar(FileBuffer)^, StrLen(PChar(FileBuffer)) );

    FileBuffer := PADS_LINES+CRLF;
    Written := PADSfile.Write(pchar(FileBuffer)^, StrLen(PChar(FileBuffer)) );
    FileBuffer := PADSLineArray.Text;
    Written := PADSfile.Write(pchar(FileBuffer)^, StrLen(PChar(FileBuffer)) );

    FileBuffer := PADS_END;
    Written := PADSfile.Write(pchar(FileBuffer)^, StrLen(PChar(FileBuffer)) );
    PADSfile.Free;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  MakePADSTextFile;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    PADSTextArray.Free;
    PADSLineArray.Free;
end;

procedure TForm1.Button2Click(Sender: TObject);
var       MemoFile: TFileStream;
          FileBuffer: AnsiString;
          MemoLine: Integer;
begin
  if Form1.SaveDialog1.Execute then begin
    MemoFile := TFileStream.Create(Form1.SaveDialog1.FileName,fmCreate or fmShareDenyNone);
    Form1.Memo1.Lines.SaveToStream( MemoFile );
    MemoFile.Free;
  end;
end;

end.
